/* screen_common.cpp
 *
 * Created on: Apr 14, 2022
 * Author: Martin Danek, martin@embedblog.eu
 */

#include "screen_include.h"
#include "SansMono_12p.h"

#include "sys.h"

void drawSystemBar()
{
	lcd.setFont(&SansMono_12p);
	uint_fast8_t hr, min, sec;
	sys::readRtc(&hr, &min, &sec);
	lcd.printf(0, 10, "%02u:%02u:%02u", hr, min, sec);
	lcd.printf(120, 10, Align::CENTER, "%4.1fC", sys::getTemperature());
	lcd.printf(240, 10, Align::RIGHT, "%d%%", sys::getBatteryPercentage());
	lcd.drawHorLine(0, 12, 240, COLOR_BLACK);
}


