/* screen_include.h
 *
 * Created on: 15. 3. 2022
 * Author: Martin Danek, martin@embedblog.eu
 */

#ifndef GFX_SCREEN_INCLUDE_H_
#define GFX_SCREEN_INCLUDE_H_

#include "screen_actions.h"
#include "UC1608.h"
extern UC1608_240x120 lcd;

void doNothing();
void doNothing(const ScreenAction action);

struct Screen
{
	void (*const onUpdate)() = doNothing;

	void (*const onEntry)() = doNothing;
	void (*const onExit)() = doNothing;

	void (*const onAction)(const ScreenAction screenAction) = doNothing;
};

void changeScreen(const Screen* const newScreen);		//defined in display.cpp
bool checkRelMode(float* value);
void drawSystemBar();									//defined in screen_common.cpp

extern const Screen screen_init,
					screen_volt,
					screen_curr,
					screen_power,
					screen_res,
					screen_aux,
					screen_cap,
					screen_thermo;

#endif /* GFX_SCREEN_INCLUDE_H_ */
