/* screen_init.cpp
 *
 * Created on: 15. 3. 2022
 * Author: Martin Danek, martin@embedblog.eu
 */

#include "screen_include.h"
#include "SansMono_24p_Bold.h"
#include "SansMono_16p.h"
#include "version.h"

static void onEntry()
{
	lcd.clear();
	lcd.setFont(&SansMono_24p_Bold);
	lcd.print(120, 40, Align::CENTER, "MULTIMETER R3.1");
	lcd.setFont(&SansMono_16p);
	lcd.printf(120, 78, Align::CENTER, "FW tag: %s", _V_BUILD_TAG);
	lcd.printf(120, 96, Align::CENTER, "FW commit: %s", _V_COMMIT);
	lcd.print(120, 118, Align::CENTER, "Martin Danek, 2022");
	lcd.displayDma();
}

const Screen screen_init =
{
	.onEntry = onEntry
};


