/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.h
  * @brief          : Header for main.c file.
  *                   This file contains the common defines of the application.
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2022 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __MAIN_H
#define __MAIN_H

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "stm32g4xx_hal.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

/* Exported types ------------------------------------------------------------*/
/* USER CODE BEGIN ET */

/* USER CODE END ET */

/* Exported constants --------------------------------------------------------*/
/* USER CODE BEGIN EC */

/* USER CODE END EC */

/* Exported macro ------------------------------------------------------------*/
/* USER CODE BEGIN EM */

/* USER CODE END EM */

void HAL_TIM_MspPostInit(TIM_HandleTypeDef *htim);

/* Exported functions prototypes ---------------------------------------------*/
void Error_Handler(void);

/* USER CODE BEGIN EFP */
void SystemClock_Config(void);
/* USER CODE END EFP */

/* Private defines -----------------------------------------------------------*/
#define SD_CS_Pin GPIO_PIN_2
#define SD_CS_GPIO_Port GPIOE
#define BUZZ_Pin GPIO_PIN_5
#define BUZZ_GPIO_Port GPIOE
#define PWR_EN_Pin GPIO_PIN_13
#define PWR_EN_GPIO_Port GPIOC
#define VRNG0_Pin GPIO_PIN_9
#define VRNG0_GPIO_Port GPIOF
#define VRNG1_Pin GPIO_PIN_10
#define VRNG1_GPIO_Port GPIOF
#define EXP11_Pin GPIO_PIN_0
#define EXP11_GPIO_Port GPIOC
#define EXP12_Pin GPIO_PIN_1
#define EXP12_GPIO_Port GPIOC
#define BATMON_Pin GPIO_PIN_3
#define BATMON_GPIO_Port GPIOA
#define GSEL0_Pin GPIO_PIN_4
#define GSEL0_GPIO_Port GPIOC
#define GSEL1_Pin GPIO_PIN_5
#define GSEL1_GPIO_Port GPIOC
#define LV_SET_Pin GPIO_PIN_0
#define LV_SET_GPIO_Port GPIOB
#define LV_RST_Pin GPIO_PIN_1
#define LV_RST_GPIO_Port GPIOB
#define IDRV2_Pin GPIO_PIN_2
#define IDRV2_GPIO_Port GPIOB
#define IRNG0_Pin GPIO_PIN_8
#define IRNG0_GPIO_Port GPIOE
#define IRNG1_Pin GPIO_PIN_9
#define IRNG1_GPIO_Port GPIOE
#define ARNG0_Pin GPIO_PIN_11
#define ARNG0_GPIO_Port GPIOE
#define ARNG1_Pin GPIO_PIN_12
#define ARNG1_GPIO_Port GPIOE
#define ARNG2_Pin GPIO_PIN_13
#define ARNG2_GPIO_Port GPIOE
#define ARNG3_Pin GPIO_PIN_14
#define ARNG3_GPIO_Port GPIOE
#define ADC_RST_Pin GPIO_PIN_15
#define ADC_RST_GPIO_Port GPIOE
#define ADC_DRDY_Pin GPIO_PIN_11
#define ADC_DRDY_GPIO_Port GPIOB
#define ADC_DRDY_EXTI_IRQn EXTI15_10_IRQn
#define ADC_CS_Pin GPIO_PIN_12
#define ADC_CS_GPIO_Port GPIOB
#define AOUT0_Pin GPIO_PIN_14
#define AOUT0_GPIO_Port GPIOD
#define AOUT1_Pin GPIO_PIN_15
#define AOUT1_GPIO_Port GPIOD
#define IDRV1_Pin GPIO_PIN_6
#define IDRV1_GPIO_Port GPIOC
#define IDRV0_Pin GPIO_PIN_7
#define IDRV0_GPIO_Port GPIOC
#define DISCH_Pin GPIO_PIN_9
#define DISCH_GPIO_Port GPIOC
#define LCD_LED_Pin GPIO_PIN_1
#define LCD_LED_GPIO_Port GPIOD
#define LCD_DC_Pin GPIO_PIN_2
#define LCD_DC_GPIO_Port GPIOD
#define BOOT_EN_Pin GPIO_PIN_9
#define BOOT_EN_GPIO_Port GPIOB
#define EXP_IRQ_Pin GPIO_PIN_1
#define EXP_IRQ_GPIO_Port GPIOE
#define EXP_IRQ_EXTI_IRQn EXTI1_IRQn
void   MX_GPIO_Init(void);
void   MX_I2C1_Init(void);
void   MX_RTC_Init(void);
void   MX_SPI2_Init(void);
void   MX_SPI3_Init(void);
void   MX_DMA_Init(void);
void   MX_USART1_UART_Init(void);
void   MX_TIM2_Init(void);
void   MX_ADC1_Init(void);
void   MX_DAC1_Init(void);
void   MX_SPI1_Init(void);
void   MX_TIM1_Init(void);
void   MX_TIM4_Init(void);
void   MX_COMP3_Init(void);
void   MX_DAC3_Init(void);
/* USER CODE BEGIN Private defines */

/* USER CODE END Private defines */

#ifdef __cplusplus
}
#endif

#endif /* __MAIN_H */
