#include "GFX_mono.h"

void GFX_mono::fillScreen(uint16_t color)
{
	switch (color)
	{
		case COLOR_BLACK:
			for (uint32_t i = 0; i < m_bufPosMax; i++)
				((uint8_t*)m_dispBuffer)[i] = 0xFF;
		break;

		case COLOR_INVERT:
		break;
			for (uint32_t i = 0; i < m_bufPosMax; i++)
				((uint8_t*)m_dispBuffer)[i] = ~((uint8_t*)m_dispBuffer)[i];

		default:
		case COLOR_WHITE:
			for (uint32_t i = 0; i < m_bufPosMax; i++)
				((uint8_t*)m_dispBuffer)[i] = 0x0;
		break;
	}
}

/**
 * @brief Draw pixel routine for displays that store data in horizontal pages, each 8 bits high ('tall'), such as UC1608
 *
 * @param x
 * @param y
 * @param color
 * @return
 */
bool GFX_mono::drawPixel(uint16_t x, uint16_t y, uint16_t color)
{
	if (x >= m_width) return false;
	if (y >= m_height) return false;

	uint16_t page = y / 8;
	uint16_t index = page * m_width + x;
	uint32_t mask = (1 << (y % 8));

	switch (color)
	{
		case COLOR_BLACK:  ((uint8_t*)m_dispBuffer)[index] |= mask; break;
		case COLOR_WHITE:  ((uint8_t*)m_dispBuffer)[index] &= ~mask; break;
		case COLOR_INVERT: ((uint8_t*)m_dispBuffer)[index] ^= mask; break;
		default: return false;
	}

	return true;
}
